from typing import Union, List, Optional

from pyspark.sql.types import StructType, DateType, DataType


# This file is auto-generated by generate_schema so do not edit manually
# noinspection PyPep8Naming
class dateSchema:
    """
    A date or partial date (e.g. just year or year + month). There is no time
    zone. The format is a union of the schema types gYear, gYearMonth and date.
    Dates SHALL be valid dates.
    If the element is present, it must have either a @value, an @id, or extensions
    """

    # noinspection PyDefaultArgument
    @staticmethod
    def get_schema(
        max_nesting_depth: Optional[int] = 6,
        nesting_depth: int = 0,
        nesting_list: List[str] = [],
        max_recursion_limit: Optional[int] = 2,
        include_extension: Optional[bool] = False,
        extension_fields: Optional[List[str]] = [
            "valueBoolean",
            "valueCode",
            "valueDate",
            "valueDateTime",
            "valueDecimal",
            "valueId",
            "valueInteger",
            "valuePositiveInt",
            "valueString",
            "valueTime",
            "valueUnsignedInt",
            "valueUri",
            "valueQuantity",
        ],
        extension_depth: int = 0,
        max_extension_depth: Optional[int] = 2,
    ) -> Union[StructType, DataType]:
        """
        A date or partial date (e.g. just year or year + month). There is no time
        zone. The format is a union of the schema types gYear, gYearMonth and date.
        Dates SHALL be valid dates.
        If the element is present, it must have either a @value, an @id, or extensions


        """
        return DateType()
