from typing import Union, List, Optional

from pyspark.sql.types import StructType, DateType, DataType, TimestampType


# This file is auto-generated by generate_schema so do not edit it manually
# noinspection PyPep8Naming
class dateTimeSchema:
    """
    A date, date-time or partial date (e.g. just year or year + month).  If hours
    and minutes are specified, a time zone SHALL be populated. The format is a
    union of the schema types gYear, gYearMonth, date and dateTime. Seconds must
    be provided due to schema type constraints but may be zero-filled and may be
    ignored.                 Dates SHALL be valid dates.
    """

    # noinspection PyDefaultArgument
    @staticmethod
    def get_schema(
        max_nesting_depth: Optional[int] = 6,
        nesting_depth: int = 0,
        nesting_list: List[str] = [],
        max_recursion_limit: Optional[int] = 2,
        include_extension: Optional[bool] = False,
        extension_fields: Optional[List[str]] = None,
        extension_depth: int = 0,
        max_extension_depth: Optional[int] = 2,
        include_modifierExtension: Optional[bool] = False,
        use_date_for: Optional[List[str]] = None,
        parent_path: Optional[str] = "",
    ) -> Union[StructType, DataType]:
        """
        A date, date-time or partial date (e.g. just year or year + month).  If hours
        and minutes are specified, a time zone SHALL be populated. The format is a
        union of the schema types gYear, gYearMonth, date and dateTime. Seconds must
        be provided due to schema type constraints but may be zero-filled and may be
        ignored.                 Dates SHALL be valid dates.


        """
        if extension_fields is None:
            extension_fields = [
                "valueBoolean",
                "valueCode",
                "valueDate",
                "valueDateTime",
                "valueDecimal",
                "valueId",
                "valueInteger",
                "valuePositiveInt",
                "valueString",
                "valueTime",
                "valueUnsignedInt",
                "valueUri",
                "valueUrl",
                "valueReference",
                "valueCodeableConcept",
                "valueAddress",
            ]
        if use_date_for and parent_path in use_date_for:
            return DateType()
        return TimestampType()
